package geniusweb.bidspace;

import static org.junit.Assert.assertEquals;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.junit.Before;
import org.junit.Test;

import geniusweb.issuevalue.DiscreteValue;
import geniusweb.issuevalue.DiscreteValueSet;
import geniusweb.issuevalue.ValueSet;
import geniusweb.profile.utilityspace.DiscreteValueSetUtilities;
import geniusweb.profile.utilityspace.ValueSetUtilities;

public class IssueInfoTest {

	private static final String NAME = "name";
	private static final DiscreteValue VAL1 = new DiscreteValue("v1"),
			VAL2 = new DiscreteValue("v2"), VAL3 = new DiscreteValue("v3");
	private static final BigDecimal N03 = new BigDecimal("0.3");
	private static final BigDecimal N04 = new BigDecimal("0.4");
	private static final BigDecimal N05 = new BigDecimal("0.5");
	private static final BigDecimal N06 = new BigDecimal("0.6");
	private IssueInfo info;

	@Before
	public void before() {
		Set<DiscreteValue> issuevalues = new HashSet<>();
		issuevalues.add(VAL1);
		issuevalues.add(VAL2);
		issuevalues.add(VAL3);
		ValueSet values = new DiscreteValueSet(issuevalues);
		Map<DiscreteValue, BigDecimal> valueUtils = new HashMap<>();
		valueUtils.put(VAL1, N03);
		valueUtils.put(VAL2, N04);
		valueUtils.put(VAL3, N05);
		ValueSetUtilities utils = new DiscreteValueSetUtilities(valueUtils);
		info = new IssueInfo(NAME, values, utils, N06, 6);
	}

	@Test
	public void smokeTest() {

	}

	@Test
	public void testGetExtremeMin() {

		assertEquals(VAL1, info.getExtreme(false));
		assertEquals(VAL3, info.getExtreme(true));
	}

	@Test
	public void getNameTest() {
		assertEquals(NAME, info.getName());
	}

	@Test
	public void getIntervalTest() {
		assertEquals(new Interval(N03.multiply(N06), N05.multiply(N06)),
				info.getInterval());
	}
}
